<template>
  <form
    class="w-full"
    @submit.prevent
  >
    <AppFlexCenterLayout column class="w-4/5 md:w-3/5 max-w-[20rem] m-auto">
      <label class="pb-2 w-full capitalize text-left">
        {{ $t('registration.email') }}
      </label>
      <input
        id="email"
        v-model="email"
        required
        name="email"
        placeholder="john@doe.eu"
        class="input w-full focus:ring-0"
        :class="[ hasError ? 'input-error' : 'border-black' ]"
      >
      <div
        v-for="(error, index) in errors"
        :key="index"
        class="alert alert-error w-full mt-2"
      >
        <div class="flex">
          <ErrorIcon class="w-6 h-6 mx-2 stroke-current" />
          <label>{{ error.$message }}</label>
        </div>
      </div>
      <div class="justify-center card-actions w-full">
        <AppButton
          class="w-full"
          :display-text="$t('registration.submit')"
          :is-loading="loading"
          :disabled="!validForm"
          v-on="$listeners"
        />
      </div>
    </AppFlexCenterLayout>
  </form>
</template>

<script lang="ts">
import { defineComponent } from '@nuxtjs/composition-api'
import ErrorIcon from '../assets/images/errorIcon.svg?inline'

export default defineComponent({
  name: 'RegistrationForm',
  components: { ErrorIcon },
  props: {
    hasError: { type: Boolean, default: false },
    errors: { type: Array, default: () => [] },
    loading: { type: Boolean, default: false },
    validForm: { type: Boolean, default: false },
    value: { type: String, default: '' }
  },
  computed: {
    email: {
      get(): string { return this.value },
      set(email: string) { this.$emit('input', email) }
    }
  }
})
</script>
